﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using ProjectBoat_bae.DrawningObjects;
using ProjectBoat_bae.Generics;
using ProjectBoat_bae.MovementStrategy;

namespace ProjectBoat_bae
{
    public partial class FormBoatCollection : Form
    {

        private readonly BoatsGenericCollection<Drawningboat, DrawningObjectBoat> _boats;

        public FormBoatCollection()
        {
            InitializeComponent();
            _boats = new BoatsGenericCollection<Drawningboat, DrawningObjectBoat>(pictureBoxCollection.Width, pictureBoxCollection.Height);
        }

        // Добавление объекта в набор
        private void buttonAddBoat_Click_Click(object sender, EventArgs e)
        {
            FormBoat form = new();
            if (form.ShowDialog() == DialogResult.OK)
            {
                if (_boats + form.SelectedBoat != -1)
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollection.Image = _boats.ShowBoats();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }
            }
        }

        // Удаление объекта из набора
        private void buttonRemoveBoat_Click_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = -1;
            try
            {
               pos = Convert.ToInt32(maskedTextBoxNumber.Text);
            }
            catch (Exception ex) { }
            if (_boats - pos)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollection.Image = _boats.ShowBoats();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }
        }

        private void buttonRefreshCollection_Click_Click(object sender, EventArgs e)
        {
            pictureBoxCollection.Image = _boats.ShowBoats();
        }
    }
}
