﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectBoat_bae.Generics
{
    internal class SetGeneric<T> where T : class
    {
        private readonly T?[] _places;

        public int Count => _places.Length;

        public SetGeneric(int count)
        {
            _places = new T?[count];
        }

        public int Insert(T boat)
        {
            if (_places[Count - 1] != null)
                return -1;
            return Insert(boat, 0);
        }

        public int Insert(T boat, int position)
        {
            if (position < 0 || position >= Count)
                return -1;
            if (_places[position] != null)
            {
                int indexEnd = position + 1;
                while (_places[indexEnd] != null)
                {
                    indexEnd++;
                }
                for (int i = indexEnd + 1; i > position; i--)
                {
                    _places[i] = _places[i - 1];
                }

            }
            _places[position] = boat;
            return position;
        }

        public bool Remove(int position)
        {
            if (position < 0 || position >= _places.Count())
                return false;

            _places[position] = null;

            return true;
        }

        public T? Get(int position)
        {
            if (position < 0 || position >= _places.Count())
                return null;
            return _places[position];
        }
    }

}